var _a;
import "@nativescript/macos-node-api";
import { Event } from "../../dom/dom-utils.js";
import { native } from "../decorators/native.js";
import { view } from "../decorators/view.js";
import { View } from "../view/view.js";
export class SliderChangeEvent extends Event {
    constructor(value, eventDict) {
        super("sliderChanged", eventDict);
        this.value = value;
    }
}
export class NSSliderAutoResizable extends NSSlider {
    static initWithOwner(owner) {
        const slider = _a.new();
        slider._owner = owner;
        return slider;
    }
    sliderChanged(_id) {
        const owner = this._owner.deref();
        if (owner) {
            owner.dispatchEvent(new SliderChangeEvent(owner.nativeView?.doubleValue || 0));
        }
    }
}
_a = NSSliderAutoResizable;
(() => {
    NativeClass(_a);
})();
NSSliderAutoResizable.ObjCExposedMethods = {
    sliderChanged: { returns: interop.types.void, params: [interop.types.id] },
};
let Slider = class Slider extends View {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
    }
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NSSliderAutoResizable.initWithOwner(new WeakRef(this));
        this.nativeView.action = "sliderChanged";
        this.nativeView.target = this.nativeView;
        return this.nativeView;
    }
};
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.numberOfTickMarks = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Slider.prototype, "numberOfTickMarks", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.allowsTickMarkValuesOnly = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], Slider.prototype, "allowsTickMarkValuesOnly", void 0);
Slider = __decorate([
    view({
        name: "HTMLSliderElement",
        tagName: "slider",
    })
], Slider);
export { Slider };
//# sourceMappingURL=slider.js.map