import "@nativescript/macos-node-api";
import { view } from "../decorators/view.js";
import { ViewBase } from "../view/view-base.js";
let TableCell = class TableCell extends ViewBase {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
        this._isEnabled = false;
    }
    initNativeView() {
        this.nativeView = NSTableCellView.new();
        return this.nativeView;
    }
    addNativeChild(child) {
        if (child.nodeName === "IMAGE") {
            this.nativeView.imageView = child.nativeView;
        }
        else if (child.nodeName === "TEXT") {
            this.nativeView.textField = child.nativeView;
        }
        this.nativeView.addSubview(child.nativeView);
    }
    removeNativeChild(child) {
        if (child.nodeName === "IMAGE") {
            this.nativeView.imageView = null;
        }
        else if (child.nodeName === "TEXT") {
            this.nativeView.textField = null;
        }
        child.nativeView?.removeFromSuperview();
    }
};
TableCell = __decorate([
    view({
        name: "HTMLTableCellElement",
        tagName: "table-cell",
    })
], TableCell);
export { TableCell };
//# sourceMappingURL=table-cell.js.map