import "@nativescript/macos-node-api";
import { view } from "../decorators/view.js";
import { ViewBase } from "./view-base.js";
let View = class View extends ViewBase {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
    }
    initNativeView() {
        this.nativeView = NSView.alloc().init();
        return this.nativeView;
    }
    disposeNativeView() {
        if (!this.nativeView?.superview) {
            this.nativeView = undefined;
        }
        else {
            console.warn("Trying to dispose a view that is still attached to it's parent", new Error().stack);
        }
    }
};
View = __decorate([
    view({
        name: "HTMLViewElement",
        tagName: "view",
    })
], View);
export { View };
//# sourceMappingURL=view.js.map